#define __SVGA_LIB__

/* SVGALib :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: */

#ifdef __SVGA_LIB__

#include <vga.h>
#include <vgagl.h>
#include "jtypes.h"

/*
   
%% ...................................................................... */
void openGraphics (
    u8** screen
    )
{
    vga_setmode(G320x200x256);
    (*screen) = graph_mem;
}


/*
   
%% ...................................................................... */
void closeGraphics()
{
    vga_setmode(TEXT);
}



/*
   
%% ...................................................................... */
void setpalvec (
    u8* pal,
    u32 a,
    u32 b
    )
{
    u32 len = (b - a + 1);
    vga_waitretrace();
    gl_setpalettecolors(a,len,pal);
}

#endif


/* X :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: */

#ifdef __X__
#include <quill.h>
#include "palette.h"

graph *g;
graph *placebo;

/*
   
%% ...................................................................... */
void openGraphics (
    u8** screen
    )
{    
    char *disp;
    disp = (unsigned char *)getenv("DISPLAY");
    if (!disp) disp = ":0.0";
    placebo = SetupGraphics(disp,160,100);
    g = SetupGraphics(disp,320,200);
    (*screen) = GetBuffer(g);
}


/*
   
%% ...................................................................... */
void closeGraphics()
{
    ShutdownGraphics(g);
    ShutdownGraphics(placebo);
}


/*
   
%% ...................................................................... */
void setpalvec (
    u8* pal,
    u32 a,
    u32 b
    )
{
    static u32     
        quillPAL[768] = {0,0,0,0,0,255};
    u32 u0,u1,u2,u3;

    pal_8to32(quillPAL,pal,(b - a + 1));
    for (u0 = 0; u0 < (b - a + 1); u0++) {
	u1 = quillPAL[u0*3];
	u2 = quillPAL[u0*3+1];
	u3 = quillPAL[u0*3+2];
	SetColor(g,u0,u1,u2,u3);
    }
}

#endif
